unit newuser;
//a modal form to create a new user
//the permissions are set by summing the tag values of the checkboxes
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, UnixCrypt;

type
  TfCreateUser = class(TForm)
    Label1: TLabel;
    edNewUser: TEdit;
    btnAddUser: TButton;
    Button1: TButton;
    Label2: TLabel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    procedure edNewUserKeyPress(Sender: TObject; var Key: Char);
    procedure btnAddUserClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    function getperms: integer;
  public
    { Public declarations }
  end;

var
  fCreateUser: TfCreateUser;

implementation
uses dmu;
{$R *.dfm}

procedure TfCreateUser.edNewUserKeyPress(Sender: TObject; var Key: Char);
begin
  btnAddUser.Enabled:=Length((Sender as TEdit).Text) > 0;
end;

procedure TfCreateUser.btnAddUserClick(Sender: TObject);
var
  i: integer;
begin
  with dm.pFIBQ do
    begin
    SQL.Clear;
    SQL.Add('select * from USERS where USERNAME = ''' + edNewUser.Text +'''');
    dm.pFIBTrans.Active:=true;
    ExecQuery;
    if eof then
      begin
      dm.pFIBQ.Close;
      SQL.Clear;
      //generate default password for new user
      dm.UnixCrypt1.Salt:=copy(edNewUser.Text,1,2);
      dm.UnixCrypt1.Key:='password';
      SQL.Add('insert into USERS (USERNAME,PWORD,PERMS) values (:NAME,:PASS,:PERMS)');
      ParamByName('NAME').AsString:= edNewUser.Text;
      ParamByName('PASS').AsString:= dm.UnixCrypt1.Result ;
      ParamByName('PERMS').AsInteger:= getperms;
      dm.pFIBTrans.Active:=true;
      ExecQuery;    
      with dm.pFIBTrans do
        if InTransaction then
          Commit;
      Close;
      end
      else
      begin
        showmessage('UserName "'+ edNewUser.Text +'" already exisits.');
        edNewUser.Clear;
        edNewUser.SetFocus;
        for i:=0 to componentcount - 1 do
          if components[i] is TCheckBox then
            TCheckBox(components[i]).Checked := false;
      end;
        
    end;
end;

function TfCreateUser.getperms: integer;
var
  i: integer;
begin
  Result:=0;
  for i:=0 to componentcount - 1 do
    if components[i] is TCheckBox then
      if TCheckBox(components[i]).Checked then
        Result := Result + TCheckBox(components[i]).Tag;
end;

procedure TfCreateUser.Button1Click(Sender: TObject);
begin
  Release;
end;

procedure TfCreateUser.FormShow(Sender: TObject);
var
  i: integer;
begin
  for i:= 0 to componentcount -1 do
    begin
    if components[i] is TCheckbox then
      (components[i] as TCheckbox).Checked := false;
    if components[i] is TEdit then
      (components[i] as TEdit).Clear:
    end;         
end;

end.
